unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    RadioGroup1: TRadioGroup;
    GroupBox3: TGroupBox;
    SpinEdit1: TSpinEdit;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    GroupBox6: TGroupBox;
    Edit3: TEdit;
    Button3: TButton;
    GroupBox7: TGroupBox;
    Memo1: TMemo;
    Timer1: TTimer;
    GroupBox8: TGroupBox;
    Button6: TButton;
    Button7: TButton;
    Edit4: TEdit;
    Memo2: TMemo;
    GroupBox9: TGroupBox;
    Button8: TButton;
    Edit5: TEdit;
    Memo3: TMemo;
    GroupBox10: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
    TGetArray=record
      Length: Word;
      Values: array[0..1023] of Single;
      end;

var
  Form1: TForm1;
  LastConState: boolean;

implementation

{$R *.dfm}

function Connect: boolean; stdcall; external 'fmio.dll';
function Connected: boolean; stdcall; external 'fmio.dll';
procedure Disconnect; stdcall; external 'fmio.dll';
procedure ConnectionSetup(ConType: boolean; PortNum: integer; Host: PChar; Port: integer); stdcall; external 'fmio.dll';
function ReadBufferLength: integer; stdcall; external 'fmio.dll';
procedure WriteCommand(Command: PChar); stdcall; external 'fmio.dll';
function ReadResponse: Pchar; stdcall; external 'fmio.dll';
function ReadValue(Key: Pchar): Pchar; stdcall; external 'fmio.dll';
function GetArray(Key: Pchar): TGetArray; stdcall; external 'fmio.dll';
procedure ClearValues; stdcall; external 'fmio.dll';

procedure TForm1.Button1Click(Sender: TObject);     //CONNECT
var ConType: boolean;
    Port: integer;
begin
if (RadioGroup1.ItemIndex=0) then ConType:=False else ConType:=True;
//ConType false = Serial port, ConType true = TCP connection
try Port:=StrToInt(Edit2.Text); except Port:=23; end;
ConnectionSetup(ConType, SpinEdit1.Value, PChar(Edit1.Text), Port);
LastConState:=false;
if (Connect) then Label1.Caption:='Connecting' else ShowMessage('Unable to connect');
end;

procedure TForm1.Button2Click(Sender: TObject);    //DISCONNECT
begin
if (Connected) then Label1.Caption:='Disconnecting' else Label1.Caption:='Not connected';
Disconnect;
end;

procedure TForm1.Button3Click(Sender: TObject);    //WRITE
begin
WriteCommand(PChar(Edit3.Text));
Edit3.Text:='';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var ConState: boolean;
begin
if (ReadBufferLength>0) then Memo1.Lines.Add(String(ReadResponse));
ConState:=Connected;
if (ConState<>LastConState) then
  begin
  if (ConState) then Label1.Caption:='Connected' else Label1.Caption:='Not connected';
  LastConState:=ConState;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);    //READ VALUE
begin
Memo2.Text:=ReadValue(PChar(Edit4.Text));
Edit4.Text:='';
end;

procedure TForm1.Button7Click(Sender: TObject);    //CLEAR VALUES
begin
ClearValues;
Memo1.Lines.Clear;
end;

procedure TForm1.Button8Click(Sender: TObject);    //GET ARRAY
var GetArrayBuf: TGetArray;
    i, length: integer;
begin
Memo3.Clear;
GetArrayBuf:=GetArray(PChar(Edit5.Text));
Edit5.Text:='';
length:=GetArrayBuf.Length;
for i:=1 to length do
  Memo3.Lines.Add(FloatToStrF(GetArrayBuf.Values[i-1],ffFixed,7,2));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Disconnect;
end;

end.
